﻿USE tempdb;
GO

-- Utworzenie tabel
CREATE TABLE Sprzedaz (
	id				INT IDENTITY(1, 1),
	pracownik_id	INT,
	data_sprzedazy	DATE,
	produkt_id		INT,
	ilosc			NUMERIC(5, 2),
	wartosc			NUMERIC(7, 2)
)

CREATE TABLE Produkt (
	id				INT,
	nazwa			VARCHAR(50)
)

CREATE TABLE Pracownik (
	id				INT,
	nazwa			VARCHAR(20),
	przelozony_id	INT
)

-- Wypełnij danymi
INSERT INTO Pracownik (id, nazwa, przelozony_id) VALUES
(1,  'Prezes',          NULL),
(2,  'Dyrektor D1',     1),
(20, 'Dyrektor D2',     1),
(3,  'Kierownik K1 D1', 2),
(4,  'Kierownik K2 D1', 2),
(5,  'Kierownik K3 D1', 2),
(6,  'Kierownik K4 D1', 2),
(7,  'Pracownik P1 K1', 3),
(8,  'Pracownik P2 K1', 3),
(9,  'Pracownik P3 K1', 3),
(10, 'Pracownik P4 K1', 3),
(11, 'Pracownik P5 K1', 3),
(12, 'Pracownik P6 K1', 3),
(13, 'Pracownik P1 K2', 4),
(15, 'Pracownik P3 K2', 4),
(16, 'Pracownik P4 K2', 4),
(17, 'Pracownik P5 K2', 4),
(18, 'Pracownik P6 K2', 4),
(21, 'Kierownik K1 D2', 20),
(22, 'Kierownik K2 D2', 20),
(23, 'Kierownik K3 D2', 20),
(24, 'Kierownik K4 D2', 20)

INSERT INTO Produkt (id, nazwa) VALUES
(10, 'Produkt 1'),
(20, 'Produkt 2'),
(30, 'Produkt 3'),
(40, 'Produkt 4'),
(50, 'Produkt 5'),
(60, 'Produkt 6'),
(70, 'Produkt 7'),
(80, 'Produkt 8')

INSERT INTO Sprzedaz (pracownik_id, data_sprzedazy, produkt_id, ilosc, wartosc) VALUES
(7, '20140507', 10, 1, 10),
(7, '20140602', 10, 1, 10),
(7, '20140815', 10, 1, 10),
(7, '20140117', 10, 1, 10),
(7, '20141127', 10, 1, 10),
(8, '20141001', 20, 4, 12),
(8, '20141021', 20, 4, 27),
(9, '20141027', 10, 5, 36),
(7, '20140903', 30, 1, 12),
(9, '20140903', 30, 2, 65),
(15, '20140304', 10, 3, 29),
(15, '20140302', 50, 3, 37),
(15, '20140512', 40, 5, 33),
(8, '20140502', 70, 1, 26),
(8, '20140422', 70, 5, 44),
(8, '20140312', 70, 21, 64),
(8, '20140519', 70, 4, 41),
(8, '20141102', 70, 4, 2),
(8, '20141203', 70, 8, 21),
(8, '20140506', 70, 1, 12),
(8, '20140412', 70, 2, 34),
(8, '20140208', 70, 3, 10),
(8, '20140205', 60, 1, 11),
(8, '20141017', 10, 4, 13),
(7, '20141027', 10, 4, 45),
(9, '20140909', 20, 2, 37),
(9, '20140910', 30, 1, 38),
(9, '20140111', 10, 2, 17),
(9, '20140311', 50, 6, 17),
(7, '20140311', 30, 6, 15),
(7, '20140407', 10, 5, 10),
(7, '20140507', 20, 3, 21),
(7, '20140507', 20, 3, 46),
(7, '20140507', 10, 1, 19),
(7, '20140507', 10, 6, 17),
(7, '20140507', 60, 6, 54),
(7, '20140507', 60, 5, 72),
(7, '20140507', 70, 2, 18),
(7, '20140507', 70, 2, 18),
(7, '20140507', 10, 1, 15)

SELECT *
FROM Sprzedaz

-- pokaż sprzedaż pracowników w danym miesiącu
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT *
FROM Dane


/* a teraz pokaż to w formacie
                    | RokMiesiac1 | RokMiesiac2 | ... | RokMiesiacX
----------+---------+-------------+-------------+-----+-------------
Pracownik | Produkt | SUMA(ilosc) | SUMA(ilosc) | ... |  SUMA(ilosc)  

*/

-- najpierw podejście standardowe
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	Pracownik,
	Produkt,
	[201401]	= CASE WHEN RokMiesiac = 201401 THEN ilosc END,
	[201402]	= CASE WHEN RokMiesiac = 201402 THEN ilosc END,
	[201403]	= CASE WHEN RokMiesiac = 201403 THEN ilosc END,
	[201404]	= CASE WHEN RokMiesiac = 201404 THEN ilosc END,
	[201405]	= CASE WHEN RokMiesiac = 201405 THEN ilosc END,
	[201406]	= CASE WHEN RokMiesiac = 201406 THEN ilosc END,
	[201407]	= CASE WHEN RokMiesiac = 201407 THEN ilosc END,
	[201408]	= CASE WHEN RokMiesiac = 201408 THEN ilosc END,
	[201409]	= CASE WHEN RokMiesiac = 201409 THEN ilosc END,
	[201410]	= CASE WHEN RokMiesiac = 201410 THEN ilosc END,
	[201411]	= CASE WHEN RokMiesiac = 201411 THEN ilosc END,
	[201412]	= CASE WHEN RokMiesiac = 201412 THEN ilosc END
FROM Dane

-- mamy rozbicie na kolumny, to teraz sumujemy
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	Pracownik,
	Produkt,
	[201401]	= SUM(CASE WHEN RokMiesiac = 201401 THEN ilosc END),
	[201402]	= SUM(CASE WHEN RokMiesiac = 201402 THEN ilosc END),
	[201403]	= SUM(CASE WHEN RokMiesiac = 201403 THEN ilosc END),
	[201404]	= SUM(CASE WHEN RokMiesiac = 201404 THEN ilosc END),
	[201405]	= SUM(CASE WHEN RokMiesiac = 201405 THEN ilosc END),
	[201406]	= SUM(CASE WHEN RokMiesiac = 201406 THEN ilosc END),
	[201407]	= SUM(CASE WHEN RokMiesiac = 201407 THEN ilosc END),
	[201408]	= SUM(CASE WHEN RokMiesiac = 201408 THEN ilosc END),
	[201409]	= SUM(CASE WHEN RokMiesiac = 201409 THEN ilosc END),
	[201410]	= SUM(CASE WHEN RokMiesiac = 201410 THEN ilosc END),
	[201411]	= SUM(CASE WHEN RokMiesiac = 201411 THEN ilosc END),
	[201412]	= SUM(CASE WHEN RokMiesiac = 201412 THEN ilosc END)
FROM Dane
GROUP BY
	Pracownik,
	Produkt


DROP TABLE Sprzedaz;
DROP TABLE Pracownik;
DROP TABLE Produkt;