﻿USE tempdb;
GO

-- sprawdź, czy mamy tabelę do przerzucenia z kolumn na wiersze
-- jeśli nie, to wykonaj skrypt na końcu PIVOT2.sql

SELECT *
FROM dbo.SprzedazPivot

-- nie znam UNPIVOTa, jak sobie poradzić bez niego?

-- 1) zrób CROSS JOINem kopie rekordu dla każdej kolumny
-- 2) przypisz wartości do kolumny docelowej
-- 3) usuń zbędne NULLe
-- 4) profit!

-- 0) kopiowanie rekordu dla każdej kolumny
SELECT * 
FROM (VALUES (201401), (201402), (201403), (201404), (201405), (201406), 
			 (201407), (201408), (201409), (201410), (201411), (201412)
) Dane(RokMiesiac)


-- 1) zrób CROSS JOINem kopie rekordu dla każdej kolumny
SELECT
	sp.*,
	x.RokMiesiac
FROM dbo.SprzedazPivot sp

	CROSS JOIN (
		SELECT * 
		FROM (VALUES (201401), (201402), (201403), (201404), (201405), (201406), 
					 (201407), (201408), (201409), (201410), (201411), (201412)
		) Dane(RokMiesiac)
	) x

-- 2) przypisz wartości do kolumny docelowej
SELECT
	sp.Pracownik,
	sp.Produkt,
	Wartosc	= CASE x.RokMiesiac
				WHEN 201401 THEN sp.[201401]
				WHEN 201402 THEN sp.[201402]
				WHEN 201403 THEN sp.[201403]
				WHEN 201404 THEN sp.[201404]
				WHEN 201405 THEN sp.[201405]
				WHEN 201406 THEN sp.[201406]
				WHEN 201407 THEN sp.[201407]
				WHEN 201408 THEN sp.[201408]
				WHEN 201409 THEN sp.[201409]
				WHEN 201410 THEN sp.[201410]
				WHEN 201411 THEN sp.[201411]
				WHEN 201412 THEN sp.[201412]
			END,
	x.RokMiesiac
FROM dbo.SprzedazPivot sp

	CROSS JOIN (
		SELECT * 
		FROM (VALUES (201401), (201402), (201403), (201404), (201405), (201406), 
					 (201407), (201408), (201409), (201410), (201411), (201412)
		) Dane(RokMiesiac)
	) x

-- 3) usuń zbędne NULLe
SELECT
	sp.Pracownik,
	sp.Produkt,
	Wartosc	= CASE x.RokMiesiac
				WHEN 201401 THEN sp.[201401]
				WHEN 201402 THEN sp.[201402]
				WHEN 201403 THEN sp.[201403]
				WHEN 201404 THEN sp.[201404]
				WHEN 201405 THEN sp.[201405]
				WHEN 201406 THEN sp.[201406]
				WHEN 201407 THEN sp.[201407]
				WHEN 201408 THEN sp.[201408]
				WHEN 201409 THEN sp.[201409]
				WHEN 201410 THEN sp.[201410]
				WHEN 201411 THEN sp.[201411]
				WHEN 201412 THEN sp.[201412]
			END,
	x.RokMiesiac
FROM dbo.SprzedazPivot sp

	CROSS JOIN (
		SELECT * 
		FROM (VALUES (201401), (201402), (201403), (201404), (201405), (201406), 
					 (201407), (201408), (201409), (201410), (201411), (201412)
		) Dane(RokMiesiac)
	) x

WHERE
	1 = 1
	--AND ... -- tutaj powtórzyć cały warunek na Wartosc?!! Zróbmy prościej!

SELECT
	sp.Pracownik,
	sp.Produkt,
	w.Wartosc,
	x.RokMiesiac
FROM dbo.SprzedazPivot sp

	CROSS JOIN (
		SELECT * 
		FROM (VALUES (201401), (201402), (201403), (201404), (201405), (201406), 
					 (201407), (201408), (201409), (201410), (201411), (201412)
		) Dane(RokMiesiac)
	) x

	CROSS APPLY (SELECT
		Wartosc = CASE x.RokMiesiac
					WHEN 201401 THEN sp.[201401]
					WHEN 201402 THEN sp.[201402]
					WHEN 201403 THEN sp.[201403]
					WHEN 201404 THEN sp.[201404]
					WHEN 201405 THEN sp.[201405]
					WHEN 201406 THEN sp.[201406]
					WHEN 201407 THEN sp.[201407]
					WHEN 201408 THEN sp.[201408]
					WHEN 201409 THEN sp.[201409]
					WHEN 201410 THEN sp.[201410]
					WHEN 201411 THEN sp.[201411]
					WHEN 201412 THEN sp.[201412]
				END
		) w

WHERE
	1 = 1
	AND w.Wartosc IS NOT NULL


-- a może da się jeszcze prościej?
SELECT
	sp.Pracownik,
	sp.Produkt,
	x.Wartosc,
	x.RokMiesiac
FROM dbo.SprzedazPivot sp

	CROSS APPLY (VALUES
		(201401, sp.[201401]),
		(201402, sp.[201402]),
		(201403, sp.[201403]),
		(201404, sp.[201404]),
		(201405, sp.[201405]),
		(201406, sp.[201406]),
		(201407, sp.[201407]),
		(201408, sp.[201408]),
		(201409, sp.[201409]),
		(201410, sp.[201410]),
		(201411, sp.[201411]),
		(201412, sp.[201412])
	) x (RokMiesiac, Wartosc)

WHERE
	1 = 1
	AND x.Wartosc IS NOT NULL

-- a co lepsze? Porównaj plany zapytań

-- super; a jak to zrobić z UNPIVOTem?

-- 1) Które kolumny mają trafić jako wiersze?
-- 2) Jak się ma nazywać kolumna, która będzie trzymała nazwy kolumn?
-- 3) Jak ma się nazywać kolumna z wartościami z tych kolumn?

SELECT
	Pracownik,
	Produkt,
	RokMiesiac,					-- 2)
	Wartosc						-- 3)
FROM SprzedazPivot

	UNPIVOT (
		Wartosc					-- 3)
		FOR RokMiesiac IN (		-- 2)
			-- 1)
			[201401], [201402], [201403], [201404], [201405], [201406],
			[201407], [201408], [201409], [201410], [201411], [201412]
		)
	) u

-- porównaj plan UNPIVOT z planem rozwiązania CROSS APPLY powyżej