﻿USE tempdb;
GO

-- dynamiczny UNPIVOT
DECLARE
  @cols AS NVARCHAR(1000),
  @sql  AS NVARCHAR(4000);

SET @cols =
  STUFF(
    (SELECT N',' + QUOTENAME(COLUMN_NAME) AS [text()]
     FROM (
		SELECT DISTINCT COLUMN_NAME
		FROM INFORMATION_SCHEMA.COLUMNS
		WHERE
			1 = 1
			AND TABLE_NAME = 'SprzedazPivot'
			AND DATA_TYPE = 'numeric'
		) Okresy
     ORDER BY COLUMN_NAME
     FOR XML PATH(''), TYPE).value('.[1]', 'VARCHAR(MAX)'), 1, 1, '')

SET @sql = N'
SELECT
	Pracownik,
	Produkt,
	RokMiesiac,
	Wartosc
FROM SprzedazPivot

	UNPIVOT (
		Wartosc
		FOR RokMiesiac IN (' + @cols + N')
	) u';
--PRINT @sql;

EXEC sys.sp_executesql @stmt = @sql;
GO


-- jak obrócić więcej niż jeden zestaw kolumn

-- przygotuj dane z więcej niż jednym zestawem do obrócenia
;WITH Dane AS (
SELECT
	Pracownik	= p.nazwa,
	Produkt		= pr.nazwa,
	RokMiesiac	= YEAR(s.data_sprzedazy) * 100 + MONTH(s.data_sprzedazy),
	s.ilosc,
	s.wartosc
FROM Sprzedaz s

	INNER JOIN Pracownik p
		ON p.id = s.pracownik_id

	INNER JOIN Produkt pr
		ON pr.id = s.produkt_id
)
SELECT
	Pracownik,
	Produkt,
	[201401_ilosc]		= SUM(d.ilosc * m.rm201401),
	[201402_ilosc]		= SUM(d.ilosc * m.rm201402),
	[201403_ilosc]		= SUM(d.ilosc * m.rm201403),
	[201404_ilosc]		= SUM(d.ilosc * m.rm201404),
	[201405_ilosc]		= SUM(d.ilosc * m.rm201405),
	[201406_ilosc]		= SUM(d.ilosc * m.rm201406),
	[201407_ilosc]		= SUM(d.ilosc * m.rm201407),
	[201408_ilosc]		= SUM(d.ilosc * m.rm201408),
	[201409_ilosc]		= SUM(d.ilosc * m.rm201409),
	[201410_ilosc]		= SUM(d.ilosc * m.rm201410),
	[201411_ilosc]		= SUM(d.ilosc * m.rm201411),
	[201412_ilosc]		= SUM(d.ilosc * m.rm201412),

	[201401_wartosc]	= SUM(d.wartosc * m.rm201401),
	[201402_wartosc]	= SUM(d.wartosc * m.rm201402),
	[201403_wartosc]	= SUM(d.wartosc * m.rm201403),
	[201404_wartosc]	= SUM(d.wartosc * m.rm201404),
	[201405_wartosc]	= SUM(d.wartosc * m.rm201405),
	[201406_wartosc]	= SUM(d.wartosc * m.rm201406),
	[201407_wartosc]	= SUM(d.wartosc * m.rm201407),
	[201408_wartosc]	= SUM(d.wartosc * m.rm201408),
	[201409_wartosc]	= SUM(d.wartosc * m.rm201409),
	[201410_wartosc]	= SUM(d.wartosc * m.rm201410),
	[201411_wartosc]	= SUM(d.wartosc * m.rm201411),
	[201412_wartosc]	= SUM(d.wartosc * m.rm201412)
INTO dbo.SprzedazPivot2
FROM Dane d

	INNER JOIN dbo.PivotMatrix m
		ON m.RokMiesiac = d.RokMiesiac

GROUP BY
	Pracownik,
	Produkt

-- zobacz co mamy
SELECT *
FROM dbo.SprzedazPivot2

-- robimy podwójnie - kolumny wartości i ilości do pojedynczej kolumny ilosc i wartosc
SELECT
	sp.Pracownik,
	sp.Produkt,
	x.RokMiesiac,
	x.Ilosc,
	x.Wartosc
FROM dbo.SprzedazPivot2 sp

	CROSS APPLY (VALUES
		(201401, sp.[201401_ilosc], sp.[201401_wartosc]),
		(201402, sp.[201402_ilosc], sp.[201402_wartosc]),
		(201403, sp.[201403_ilosc], sp.[201403_wartosc]),
		(201404, sp.[201404_ilosc], sp.[201404_wartosc]),
		(201405, sp.[201405_ilosc], sp.[201405_wartosc]),
		(201406, sp.[201406_ilosc], sp.[201406_wartosc]),
		(201407, sp.[201407_ilosc], sp.[201407_wartosc]),
		(201408, sp.[201408_ilosc], sp.[201408_wartosc]),
		(201409, sp.[201409_ilosc], sp.[201409_wartosc]),
		(201410, sp.[201410_ilosc], sp.[201410_wartosc]),
		(201411, sp.[201411_ilosc], sp.[201411_wartosc]),
		(201412, sp.[201412_ilosc], sp.[201412_wartosc])
	) x (RokMiesiac, Ilosc, Wartosc)

WHERE
	1 = 1
	AND (x.Ilosc IS NOT NULL OR x.Wartosc IS NOT NULL)
